#include "stdlib.h"
#include "stdio.h"

#define MAX_BUFFER 5000
#define MAX_CMD_LENGTH 40960

unsigned long ScrollItem = 0;
extern WORD wt;
extern WORD m_ComPort;
typedef struct packet
{	
	LONGLONG MsgTimeStamps;
	BYTE  mode;
	DWORD id;
	BYTE  rtr;
	BYTE  len;
	BYTE  data[8];
} PacketStruct;
extern PacketStruct RxData[];

extern int NewData,OldData;
extern BOOL BusyFlag1;
extern BOOL BusyFlag2;
extern unsigned long MesgCount;
extern CMSFlexGrid* ms_ReceiveList;
extern unsigned long TimeOutCnt;
extern BOOL ClearList;
extern int Scrolling;
extern BOOL ThreadFlag;

extern void SetTextMatrix();

extern int CmdIdx,ResponseIdx;

inline char Ascii_to_Hex(char CheckStr)
{
	if (CheckStr>0x2f){
		CheckStr-=0x30;
		if (CheckStr>9) CheckStr-=7;
		if (CheckStr>15) return -1;
	}
	else	return -1;

	return CheckStr;
}

inline unsigned long StrToCANID(char &CheckStr)
{
	if (CheckStr>0x2f){
		CheckStr-=0x30;
		if (CheckStr>9) CheckStr-=7;
		if (CheckStr>15) return -1;
	}
	else	return -1;

	return CheckStr;
}

//static int testcnt=0;
inline Receive_Thread(BYTE* PortIndex)
{

	char Com_Data[MAX_CMD_LENGTH];
	char RecvData[30],*stopstring;
	int DataSize;
	//char test[100];
	//int CmdIdx=0,ResponseIdx=0;

	while(1)
	{
		if(DataSizeInCom((int)m_ComPort) > 0)
		{
			PacketStruct ReceiveTemp;
			int SFlag=0,FFlag=0,RecvLen=0;
			int wmaxLen=0,FindEndChar=0;
			int i,idx;

			if(ResponseIdx==0)	CmdIdx=0;
			idx=ResponseIdx;

			DataSize=ReadComn((unsigned char)m_ComPort, &Com_Data[idx], MAX_CMD_LENGTH-idx, &wt);
			if(DataSize)	idx+=DataSize;

			if(idx){
			
			//wsprintf(test,"idx=%d,DataSize=%d,CmdIdx=%d,Com_Data=%s",idx,DataSize,CmdIdx,&Com_Data[CmdIdx]);
			//MessageBox(NULL,test,_T("Message"),NULL);

				while(CmdIdx < idx-1)
				{
					FindEndChar=0;
					for(i=CmdIdx;i<idx;i++)
					{
						if(Com_Data[i]==0x0D)
						{
							SFlag=CmdIdx;
							FFlag=i;
							FindEndChar=1;
							break;
						}

						if((FindEndChar==0) && (i>CmdIdx+28)){
							CmdIdx=CmdIdx+i;
							break;
						}
					}

					if(FindEndChar==0)		break;

					RecvLen=FFlag-SFlag+1;
					memset(RecvData, '\0', sizeof(RecvData));
					strncpy(RecvData,&Com_Data[SFlag],RecvLen);

					switch(RecvData[0])
					{
						case 't':
							ReceiveTemp.mode=0;
							ReceiveTemp.rtr=0;
							wmaxLen=3;
						break;
						case 'T':
							ReceiveTemp.mode=0;
							ReceiveTemp.rtr=1;
							wmaxLen=3;
						break;
						case 'e':
							ReceiveTemp.mode=1;
							ReceiveTemp.rtr=0;
							wmaxLen=8;
						break;
						case 'E':
							ReceiveTemp.mode=1;
							ReceiveTemp.rtr=1;
							wmaxLen=8;
						break;
						default:
							CmdIdx=CmdIdx+RecvLen;
							continue;
						break;
					}

					char tmpRecvData[10];
					strncpy(tmpRecvData,&RecvData[1],wmaxLen);
					tmpRecvData[wmaxLen]=NULL;

					if(ReceiveTemp.mode==0)
					{
						ReceiveTemp.id= strtol(tmpRecvData,&stopstring,16)&0x7FF;
					}
					else
					{
						ReceiveTemp.id= strtol(tmpRecvData,&stopstring,16)&0x1FFFFFFF;
					}

					ReceiveTemp.len=Ascii_to_Hex(RecvData[wmaxLen+1]);

					int tmpRecvLen;
					
					if(ReceiveTemp.rtr==0)
					{
						tmpRecvLen=wmaxLen+ReceiveTemp.len*2+3; //include CR
						if((ReceiveTemp.len<0) || (ReceiveTemp.len>8) || (tmpRecvLen != RecvLen))
						{
							CmdIdx=CmdIdx+RecvLen;
							continue;
						}
					}
					else	tmpRecvLen=wmaxLen+3; //include CR

				
					
					if(RecvData[tmpRecvLen-1] == 0x0D)
					{
						wmaxLen=wmaxLen+2;
						if(ReceiveTemp.rtr == 0)
						{
							for(i=0;i<ReceiveTemp.len;i++)
							{
								ReceiveTemp.data[i]=(Ascii_to_Hex(RecvData[wmaxLen+i*2])<<4) + Ascii_to_Hex(RecvData[wmaxLen+i*2+1]);
							}
						}
					}
					else
					{
						CmdIdx=CmdIdx+RecvLen;
						continue;
					}


					RxData[NewData].mode = ReceiveTemp.mode;
					RxData[NewData].id = ReceiveTemp.id;
					RxData[NewData].rtr = ReceiveTemp.rtr;
					RxData[NewData].len = ReceiveTemp.len;
					//RxData[NewData].MsgTimeStamps = ReceiveTemp.MsgTimeStamps;
					for(i=0;i<RxData[NewData].len;i++)
						RxData[NewData].data[i] = ReceiveTemp.data[i];
					
					BusyFlag2 = 1;
					NewData++;

					if(NewData >= MAX_BUFFER) NewData = 0;

					if(NewData == OldData)
					{
						while(BusyFlag1)
						{
							Sleep(1);
						}
						if(NewData == OldData){
							OldData++;
							if(OldData >= MAX_BUFFER) OldData = 0;
						}
					}

					CmdIdx=CmdIdx+RecvLen;
					
					BusyFlag2 = 0;
				}
				if(CmdIdx == idx)	ResponseIdx=0;
				else	ResponseIdx=idx;
			}
		}
		else
		{
			Sleep(1);
		}
	}
}

inline Analyze_Thread(BYTE* PortIndex)
{
	
	BYTE PortThread = *PortIndex;
	BYTE j;
	//double timestamp;
	CString MesgStr;


	while(1)
	{
		while(OldData != NewData && BusyFlag2 == 0)
		{
			BusyFlag1 = 1;
			if (MesgCount>=20000){

				ms_ReceiveList->Clear();
				SetTextMatrix();
				ms_ReceiveList->SetTopRow(1);
				MesgCount=0;
			}

			MesgStr.Format("%lu",++MesgCount);
			ms_ReceiveList->SetTextMatrix(MesgCount,0,MesgStr);

			MesgStr.Format(_T("%X"),RxData[OldData].mode);
			ms_ReceiveList->SetTextMatrix(MesgCount,1,MesgStr);

			MesgStr.Format(_T("%X"),RxData[OldData].id);
			ms_ReceiveList->SetTextMatrix(MesgCount,2,MesgStr);

			MesgStr.Format(_T("%X"),RxData[OldData].rtr);
			ms_ReceiveList->SetTextMatrix(MesgCount,3,MesgStr);

			MesgStr.Format(_T("%X"),RxData[OldData].len);
			ms_ReceiveList->SetTextMatrix(MesgCount,4,MesgStr);

			if(RxData[OldData].rtr == 0)
			{
				for(j=0;j<8;j++){
					if(j == RxData[OldData].len) break;
					MesgStr.Format(_T("%X"),RxData[OldData].data[j]);
					ms_ReceiveList->SetTextMatrix(MesgCount,j+5,MesgStr);
				}
			}

			TimeOutCnt = 20000;
			

			OldData++;
			if(OldData == MAX_BUFFER) OldData = 0;

			BusyFlag1 = 0;
		}

		if(ScrollItem != MesgCount+1){
			if(Scrolling){
				if (MesgCount>5){
					ms_ReceiveList->SetTopRow(MesgCount-5);
				}
			}
			ScrollItem = MesgCount+1;
		}

		if(ClearList){
			ms_ReceiveList->Clear();
			SetTextMatrix();
			ms_ReceiveList->SetTopRow(1);
			ClearList = 0;
			MesgCount = 0;
		}	
		
		if(TimeOutCnt){
			TimeOutCnt--;
			Sleep(0);
		}
		else
			Sleep(1);
	}
	

}

DWORD WINAPI ReceiveThread(LPVOID lpParameter)
{
	BYTE *PortIndex = (BYTE*)lpParameter;

	Receive_Thread(PortIndex);
	return 0;
}

DWORD WINAPI AnalyzeThread(LPVOID lpParameter)
{
	BYTE *PortIndex = (BYTE*)lpParameter;

	Analyze_Thread(PortIndex);
	return 0;
}
